//
//  AssessmentInstance.h
//  mHOMES
//
//  Created by Pedrum Golriz on 4/23/15.
//
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>

@class ResponseInstance;

@interface AssessmentInstance : NSManagedObject

@property (nonatomic, retain) NSString * assessmentDate;
@property (nonatomic, retain) NSString * assessmentFormVersion;
@property (nonatomic, retain) NSNumber * currentSectionIndex;
@property (nonatomic, retain) NSNumber * finished;
@property (nonatomic, retain) NSNumber * isDecisionSupport;
@property (nonatomic, retain) NSNumber * reassessment;
@property (nonatomic, retain) NSString * stationNumber;
@property (nonatomic, retain) NSString * submitDate;
@property (nonatomic, retain) NSString * userId;
@property (nonatomic, retain) NSString * veteranFirstName;
@property (nonatomic, retain) NSString * veteranHomesId;
@property (nonatomic, retain) NSString * veteranLastName;
@property (nonatomic, retain) NSString * veteranLocalID;
@property (nonatomic, retain) NSString * veteranSSN;
@property (nonatomic, retain) NSOrderedSet *responses;
@end

@interface AssessmentInstance (CoreDataGeneratedAccessors)

- (void)insertObject:(ResponseInstance *)value inResponsesAtIndex:(NSUInteger)idx;
- (void)removeObjectFromResponsesAtIndex:(NSUInteger)idx;
- (void)insertResponses:(NSArray *)value atIndexes:(NSIndexSet *)indexes;
- (void)removeResponsesAtIndexes:(NSIndexSet *)indexes;
- (void)replaceObjectInResponsesAtIndex:(NSUInteger)idx withObject:(ResponseInstance *)value;
- (void)replaceResponsesAtIndexes:(NSIndexSet *)indexes withResponses:(NSArray *)values;
- (void)addResponsesObject:(ResponseInstance *)value;
- (void)removeResponsesObject:(ResponseInstance *)value;
- (void)addResponses:(NSOrderedSet *)values;
- (void)removeResponses:(NSOrderedSet *)values;
@end
