#import "mHomesTests.h"
#import "CoreDataPlugin.h"


@implementation mHomesTests

CoreDataPlugin *_plugin;
NSDictionary *_vet1;

NSString *vetLastName = @"Veteran1";
NSString *vetSSN = @"123456789";


-(void)setUp {
    [super setUp];

    _plugin = [[CoreDataPlugin alloc] init];
    _vet1 = @{  @"lastName": vetName,
                @"ssn": vetSSN
            };
}

-(void)tearDown {
    [super tearDown];
}

-(void)test1SaveVeteran {
    
    NSError *error = nil;
    
    error = [_plugin saveVeteran:[NSArray arrayWithObjects:_vet1, nil]];
    STAssertTrue(error == nil, [NSString stringWithFormat:@"Error saving veteran, %@", error.localizedDescription]);
}

-(void)test2FetchVeteran {
    
    NSManagedObject *returnedObject = [_plugin findVeteran:vetSSN];
    
    if (returnedObject != nil) {
        STAssertTrue([vetLastName isEqualToString:[returnedObject valueForKey:@"lastName"]], @"Veteran last name does not match");
        
    } else {
        STFail(@"Fetch returned no veterans");
    }
}

-(void)test3DeleteVeteran {
    
    NSError *error = [_plugin deleteVeteran:vetSSN];
    
    STAssertTrue(error == nil, [NSString stringWithFormat:@"Error deleting veteran, %@", error.localizedDescription]);
}

@end
