#!/bin/sh

killall "iPhone Simulator"

touch test-results.txt
DATE=$(date +"%Y-%m-%d-%H-%M")
LOG=$DATE-test-results.txt
mv test-results.txt $LOG

echo "Building mHOMES"

./../cordova/build

killall Appium

echo Agilexadmin99$ | sudo -S authorize_ios


appium --app ../build/mHOMES.app &
sleep 30

echo "Appium Started"

for TEST_SCRIPT in *.rb; do
echo "Running Test Script" $TEST_SCRIPT
echo "\n\n\n" >> $LOG
echo $TEST_SCRIPT >> $LOG
echo "Starting Tests\n" >> $LOG
rspec $TEST_SCRIPT >>$LOG 2>&1

done

if grep -Fxq "Failures:" $LOG
then
	echo "Failures found in tests. Check Log: " $LOG
	echo "\n"
	cat $LOG
	exit 1;

else
	echo "No Failures. All Tests Passed"
fi
