define(
	['Global', 'App', 'Form'],
	function(Global, App, Form) {
		'use strict';
		var singleInstance,collection,
		Forms = Backbone.Collection.extend({
			model:		Form,
			initialize: function(data) {
				collection = this;
			},
			addTo: function(data) {
				var ids = collection.list();
				if ($.isArray(data)) {
					for (var i in data) {
//						console.log('REPORT adding FormID=' + data[i].FormID, 'type=' + data[i].FormType);
						collection.addIfNew(ids,data[i]);
					}
				} else {
//					console.log('REPORT adding FormID=' + data.FormID, 'type=' + data.FormType);
					collection.addIfNew(ids,data);
				}
//				collection.reportOn();
			},
			addIfNew: function(ids,data) {
				var formId = data.FormID;
				if (formId) {
					var found = false;
					for (var i in ids) {
						if (ids[i]===formId) {
							found = true;
							break;
						}
					}
					if (found) {
//						console.log('REPORT not adding ' + formId + ' because its already there');
					} else {
						collection.add(data);
					}
				}
			},
			list: function() {
				var ids = [];
				collection.each(function(model) {
					ids.push(model.get('FormID'));
				});
				return ids;
			},
			reportOn: function() {
				collection.each(function(model) {
					console.log('REPORT collection has FormID=' + model.get('FormID'), 'type=' + model.get('FormType'));
				});
			}
		});

		Forms.instance = function (data) {
			if (typeof singleInstance === "undefined") {
				singleInstance = new Forms(data);
			}
            return singleInstance;
        };

        Forms.clearInstance = function() {
            singleInstance = undefined;
        };

        return Forms;
	}
);
