require.config({
	paths: {
		// Libraries
		'jQuery':						'libs/jquery-1.9.1.min',
		// custom version of jQM, see comments section in library for custom change log
		'jQM':							'libs/jquery.mobile-1.3.2.min',
		'Underscore':					'libs/underscore-1.4.4.min',
		'Backbone':						'libs/backbone-1.0.min',
		//'FormParams':					'libs/jquery.formparams',
		'jQMConfig':					'libs/jqm-config', // Disables JQM Routing
		'Soap':							'libs/jquery.soap',
		'Xml2Json':						'libs/jquery.xml2json',
		'Cookie':						'libs/jquery.cookie',
		'Modal':						'libs/Backbone.ModalDialog',
		'ScrollTo':						'libs/jquery.scrollTo.min',
		'DatePicker':					'libs/jquery.accessibleDatePicker',

		// Application Libraries
		'Global':						'global',
		'Utilities':					'util/utilities',
		'App':							'app',
		'HomesSoap':					'util/homesSoap',
		'HomesLib':						'util/homesLib',
		'CordovaLib':					'util/cordovaLib',
		'Security':						'util/security',
		'MetricLib':						'util/metricLib',
		'SideBar':						'util/sidebar',
		'Templates':					'forms/templates',
		'FormRules':					'forms/formRules',

		// Models
		'HomesUser':					'models/homes/homesUser',
		'HomesVet':						'models/homes/homesVet',
		'HomesAssessment':              'models/homes/homesAssessment',
		'Form':							'models/homes/form',
		'Metric':						'models/homes/metric',

		'QuestionsData':				'models/questionsData',
		'FormData':						'models/formData',
		'Response':						'models/response',

		// Collections
		'HomesVets':					'collections/homes/homesVets',
		'Forms':						'collections/homes/forms',

		'Responses':					'collections/responses',

		// Views
		'MainView':						'views/mainView',
		'HeaderView':					'views/headerView',
		'FooterView':					'views/footerView',
		'MessageView':					'views/messageView',
		'ErrorView':					'views/errorView',
		'SecondaryHeaderView':			'views/secondaryHeaderView',
		'BlankView':					'views/blankView',
		'EulaView':						'views/eulaView',
		'SudView':						'views/sudView',
		'DateView':						'views/dateView',

		'HomesLoginView':				'views/homes/homesLoginView',
		'BlankView':					'views/homes/blankView',
		'HomesListView':				'views/homes/homesListView',
		'HomesVeteranSummaryView':		'views/homes/homesVeteranSummaryView',
		'HomesSavedDataView':			'views/homes/homesSavedDataView',
		'HomesAssessmentView':			'views/homes/homesAssessmentView',
		'HDSView':						'views/homes/hdsView',
		'HistoryView':					'views/homes/historyView',
		'FormView':						'views/homes/formView',
		'ConfigView':					'views/homes/configView',
		'AboutView':					'views/homes/aboutView',
		'RecommendView':				'views/homes/recommendView',

		// require js plugins
		'Text':							 'libs/text'
	},
	waitSeconds: 30,
	shim: {
		'jQuery': {
			exports: '$'
		},
		'jQMConfig': {
			deps: ['jQuery']
		},
		'Soap': {
			deps: ['jQuery']
		},
		'Xml2Json': {
			deps: ['jQuery']
		},
		'ScrollTo': {
			deps: ['jQuery']
		},
		'Cookie': {
			deps: ['jQuery']
		},
		'jQM': {
			deps: ['jQMConfig']
		},
        'DatePicker': {
            deps: ['jQuery']
        },
		'Underscore': {
			exports: '_'
		},
		'Backbone': {
			deps: ['Underscore', 'jQuery'],
			exports: 'Backbone'
		},
		'Utilities': {
			deps: ['Backbone']
		},
		'Security': {
			deps: ['jQuery']
		},
		'Global': {
			deps: ['Backbone', 'Utilities', 'Soap', 'Xml2Json', 'App', 'Templates', 'Cookie', 'Modal', 'ScrollTo']
		},
		'Modal': {
			deps: ['Backbone']
		}
	}
});

require(['router']);
