define(
	['Global', 'App', 'HomesUser', 'HomesVet', 'Responses', 'FormRules'],
	function(Global, App, HomesUser, HomesVet, Responses, FormRules) {
		var response, model, singleInstance, successCallback,
		HomesAssessment = Backbone.Model.extend({
			defaults: {
				veteranHomesId:			"",
				veteranFirstName:       '',
				veteranLastName:        '',
				submitDate:				"",
				assessmentDate:			"",
				finished:               false,
				formID:					'',
				reassessment:			false
			},
			initialize: function() {
				model = this;
			},
			updateFromLocal: function(local,isDsForm) {
//				console.log('updateFromLocal ' + JSON.stringify(local));
				if (local) {
					model.set('veteranHomesId',	local.veteranHomesId);
					model.set('submitDate',		local.submitDate);
					model.set('reassessment',	local.reassessment);
					console.log('reassessment=' + model.get('reassessment'));

					console.log('isDsForm=' + isDsForm);
					if (isDsForm) {
						Responses.newInstance().setDefaults_HDS();
					} else {
						Responses.newInstance().setDefaults_HOMES();
					}
					FormRules.getSoapLogic().fromLocalStorage(local.responses); // directly updates Responses object
				}
//				console.log('updateFromLocal Q18c=' + Responses.instance().getAnswer('ddlHSA_Q18c'));
			},
			updateFromVA: function(vaData) {
				console.log('updateFromVA ' + JSON.stringify(vaData));

				model.set('veteranHomesId',	vaData.VeteranID);
				model.set('formID',			vaData.FormID);
				model.set('submitDate',		vaData.SubmitDate);
				model.set('reassessment',	true);

				// only HOMES assessments come from the VA
				Responses.newInstance().setDefaults_HOMES();
				for (var i in vaData.Responses.Response) {
					var vaId = vaData.Responses.Response[i].QuestionID;
					var answer = vaData.Responses.Response[i].ResponseValue;
					Responses.instance().fromVAforAssessment(vaId,answer);
				}
			},
			createNew: function(isDsForm) {
				var vet = HomesVet.getCurrentVet();
				if (vet) {
					model.set('veteranHomesId',	vet.get('veteranID'));
					model.set('formID',			'');
					model.set('submitDate',		'');
					model.set('reassessment',	false);
				}
				console.log('createNew model=' + JSON.stringify(model));
				if (isDsForm) {
					Responses.newInstance().setDefaults_HDS();
				} else {
					Responses.newInstance().setDefaults_HOMES();
				}
				console.log('createNew responses=' + JSON.stringify(Responses.instance()));
			}
		});

		HomesAssessment.instance = function (params) {
			if (typeof singleInstance === "undefined") {
				singleInstance = new HomesAssessment(params);
			}
			return singleInstance;
		};

		HomesAssessment.newInstance = function() {
			HomesAssessment.clearInstance();
			return HomesAssessment.instance();
		};

		HomesAssessment.clearInstance = function() {
			singleInstance = undefined;
		};

		return HomesAssessment;
	}
);
