define([
	'Global', 'App'
	],
	function(Global,App) {
		var singleInstance, model;
		var HomesUser = Backbone.Model.extend({
			defaults: {
				StaffName:			'',
				Email:				'',
				LevelOfAccess:		'',
				LoginId:			'',
				SiteCode:			'',
				username:			'',
                Authenticated:      false,
                Roles:              [],
                loggedIn:			false
			},
			initialize: function(params) {
				model = this;
			},
			isLoggedIn: function() {
				return model.get('loggedIn');
			},
			rememberCreds: function() {
				App.getState().username = this.get('username');
			},
			logout: function() {
				model.set('loggedIn',false);
				model.set('username', '');
				model.set('password', '');
			},
			forgetStoredCreds: function() {
				App.getState().username = '';
			}
		});

		HomesUser.instance = function(params) {
			if (typeof singleInstance === "undefined") {
				singleInstance = new HomesUser(params);
			}
			return singleInstance;
		};

		HomesUser.clearInstance = function() {
			singleInstance = undefined;
		};

		return HomesUser;
	}
);
