define(
	['App', 'Global', 'CordovaLib'],
	function(App,Global,CordovaLib) {
		var library;
		var metricLib = {
			init: function() {
				library = this;
				return this;
			},
			fetchFromCordova: function(success,fail) {
				CordovaLib.fetchMetrics(function(obj) {
					if (obj.success) {
						console.log('METRIC fetchFromCordova succeeded');
						success(obj);
					} else {
						console.log('METRIC fetchFromCordova failed');
						fail(obj);
					}
				});
			},
			saveToCordova: function(metric,success,fail) {
				CordovaLib.storeMetric(metric, function(obj) {
					if (obj.success) {
						console.log('METRIC saveToCordova succeeded');
						success(obj);
					} else {
						console.log('METRIC saveToCordova failed');
						fail(obj);
					}
				})
			},
			deleteFromCordova: function(metricID) {
				CordovaLib.deleteMetric(metricID, function(obj) {
					if (obj.success) {
						console.log('METRIC deleteFromCordova succeeded ' + metricID);
					} else {
						console.log('METRIC deleteFromCordova failed ' + metricID);
					}
				})
			},
			saveMetric: function(metric,success,fail) {
				console.log('saveMetric saving with startDate=' + metric.get('startDate'));
				metric.save({}, {
					wait: false,
					async: true,
					headers: {
						"Authorization":	"Basic " + btoa(App.getState().metricClient + ':' + App.getState().metricSecret),
					},
				})
				.done(function(model, response, options) {
						console.log('METRIC saveMetric succeeded');
						success(model, response, options);
					}
				)
				.fail(function(xhr, response, error) {
						console.log('METRIC saveMetric failed');
						console.log('METRIC error response=' + JSON.stringify(response));
						console.log('METRIC error error=' + JSON.stringify(error));
						fail(xhr, response, error);
					}
				);
			}
		}.init();
		return metricLib;
	}
);
