define(
	['App', 'Global', 'HomesUser', 'HomesVet'],
	function(App,Global,HomesUser,HomesVet) {
		var library;
		var sideBar = {
			init: function() {
				library = this;
				return library;
			},
			clearBackground: function() {
				$('.sidebar a').each(function() {
					$(this).removeClass('highlighted');
				})
			},
			changeBackground: function(elem) {
				library.clearBackground();
				library.modifyButtons();
				if (elem) {
					$(elem).addClass('highlighted');
				}
			},
			modifyButtons: function() {
				console.log('modifyButtons');
				var loggedIn = HomesUser.instance().isLoggedIn();
				var hasVet = HomesVet.getCurrentVet() != null;
				$('.sidebar a').each(function() {
					$(this).removeClass('ui-disabled');
				})
                if (!loggedIn || !hasVet) {
					$('#contact-btn').addClass('ui-disabled');
					$('#history-btn').addClass('ui-disabled');
					$('#assessment-btn').addClass('ui-disabled');
					$('#decision-btn').addClass('ui-disabled');
                }

				if (loggedIn) {
					$('#about-btn').removeClass('hidden');
				} else {
					$('#about-btn').addClass('hidden');
				}

				var hasEpisode = HomesVet.getCurrentVet() && HomesVet.getCurrentVet().get('isHomesEpisodeOpen');
//				console.log('refresh hasEpisode=' + hasEpisode + ', vet=' + JSON.stringify(HomesVet.getCurrentVet()));

				if (hasEpisode) {
                    if (HomesVet.getCurrentVet().get('homesEpisodeVISN') == HomesUser.instance().get('VISN')) {
                        $('#assessment-btn').buttonMarkup({ icon: 'assessment-open-noedit' });
                    } else {
                        $('#assessment-btn').buttonMarkup({ icon: 'assessment-open-edit' });
                    }

				} else {
                    $('#assessment-btn').buttonMarkup({ icon: 'assessment-normal' });
				}
			},
		}.init();

		return sideBar
	}
);
