define([
	'Global','App',
	'DatePicker',
	'Text!../html/templates/panes/date.html'
],
	function (Global, App, DatePicker, template) {
		"use strict";
		var view;
		return Backbone.View.extend({
			id: "date-menu",
			attributes: {
				"data-role": "popup",
				"data-overlay-theme": "a",
				"data-dismissable": "false",
				"data-shadow": "true",
				"data-theme": "a",
				"class": "ui-corner-all"
			},
			initialize: function (metaData) {
				view = this;
				view.metaData = metaData;
				view.template = _.template(template);
				view.metaData.date		= view.metaData.date || subtractFromDate(0, 0, 0, 0, 0, 0, 0, new Date());
				view.metaData.caller	= view.metaData.caller || null;
				view.metaData.yearsBack = view.metaData.yearsBack || 100;
			},
			render: function () {
				console.log('dateView render');
				view.destroy();
				$('#main-content').append(view.$el.append(view.template(view.metaData)));
				view.activatePopup();
				view.delegateEvents();
				return view;
			},
			events: {
				'click #apply-btn':			'apply',
				'tap [title="Close"]':		'close'
			},
			close: function () {
			},
			activatePopup: function () {
				var $rangeMenu = view.$el;

				$rangeMenu.trigger('create');
				$rangeMenu.popup();
				$rangeMenu.popup('open');

				view.$date = $('#date');
				var closeDatePicker = function () {
					console.log('closeDatePicker');
					var dateValue = view.$date.val();
					view.$el.popup('open');
					$('#apply-btn').button('enable');
				};

				view.$date.accessibleCalendar({
					onClose: closeDatePicker,
					"leading-zero": true
				});

				view.$date.focus();
				view.restrictDate();
			},
			restrictDate: function () {
				var today = new Date(),
					fromMin = new Date().setFullYear(today.getFullYear() - view.metaData.yearsBack);
				view.$date.data().options = {
					MIN: fromMin,
					MAX: today
				};
			},
			apply: function (e) {
				console.log('apply');
				if (view.metaData.onApply) {
					var date = $('#date', $(e.currentTarget).parents('form'));
					view.metaData.onApply(date.val());
				}

				view.$el.popup('close');
			},
			destroy: function () {
				$('#date-menu, #date-picker').remove();
			}
		});
	}
);
