define([
    'Backbone',
    'Text!../html/templates/errors/Error404View.html',
    'Text!../html/templates/errors/Error503View.html',
    'Text!../html/templates/errors/Error500View.html',
    'Text!../html/templates/errors/Error401View.html',
    'Text!../html/templates/errors/Error419View.html',
], function (Backbone, Error404ViewTemplate, Error503ViewTemplate, Error500ViewTemplate, Error401ViewTemplate, Error419ViewTemplate) {
    
    var ErrorView = Backbone.View.extend({
        
        initialize: function (options) {
            
            if (options !== undefined) {
                this.errorTemplate = this.setError(options.errorCode);
            }
        },
        setError: function(errorCode) {
            if (errorCode == 404) {
                return  (_.template(Error404ViewTemplate))();
            } else if (errorCode == 503) {
                return  (_.template(Error503ViewTemplate))();
            } else if (errorCode == 500) {
                return (_.template(Error500ViewTemplate))();
            } else if (errorCode == 401) {
                return (_.template(Error401ViewTemplate))();
//            } else if (errorCode == 419) {
//                return (_.template(Error419ViewTemplate))({'loginUrl': this.authorizationTokenHandler.getLoginUri()});
            }
        },
        render: function () {
            if (this.errorTemplate !== undefined) {
                this.$el.append(this.errorTemplate);
            }
            
            $('#main').empty().append(this.$el);
            return this;
        }
    });

    return ErrorView;
});
