define([
	'Global',
	'Text!../html/templates/panes/eula.html',
	'Text!../html/templates/panes/eulaFooter.html'
],
	function (Global, eulaTemplate, eulaFooterTemplate) {
		var view;
		var EulaView = Backbone.View.extend({
			id: 'eula',
			tagName: 'div',
			attributes: {'data-role': 'dialog'},
			initialize: function (metaData) {
				view = this;
				view.template = _.template(eulaTemplate);
				view.footerTemplate = _.template(eulaFooterTemplate);
				view.metaData = metaData ? metaData : {};
			},
			render: function () {
				this.$el
					.empty()
					.append(this.template(view.metaData))
					.append(this.footerTemplate(view.metaData));
				var $container = $('body');
				$container.append(view.$el);
				view.delegateEvents(view.events); // we lose the event handlers if the router reloads this page
			},
			events: {
				'tap #accept-btn': 'accept',
				'tap #decline-btn': 'decline',
				'tap .ui-header a[Title="Close"]': 'close'
			},
			accept: function () {
				var key = view.metaData.key;
				var value = { dateAccepted: new Date().getTime() };
				Global.getUtilities().writeToStorage(key,value);
				Global.getUtilities().eventAggregator.invoke('homesLogin');
			},
			decline: function (e) {
				e.preventDefault();
				e.stopPropagation();
				Global.getUtilities().eventAggregator.trigger('message', 'mustAgree');
			},
			close: function (e) {
				e.preventDefault();
				e.stopPropagation();
				Global.getUtilities().eventAggregator.trigger('message', 'mustAgree');
				Global.getUtilities().eventAggregator.invoke('eula');
			}
		});
		return EulaView;
	}
);
