define([
	'Global', 'App', 'HomesUser',
	'Text!../html/templates/navbars/footer.html'
	],
	function(Global, App, HomesUser, footerTemplate) {
		var view,options,
		FooterView = Backbone.View.extend({
			initialize : function() {
				view = this;
                view.template = _.template(footerTemplate);
                options = {
                	name: '',
                	site: '',
                	roles: '',
                	appVersion: ''
                }
			},
			render : function(data) {
				for (var key in data) {
					options[key] = data[key];
				}
				var homeUser = HomesUser.instance();
				options.name = homeUser.get('StaffName');
				options.site = homeUser.get('SiteCode');
				var arr = homeUser.get('Roles');
				if (arr) {
					var roles = '';
					for (var i=0; i<arr.length; i++) {
						if (i > 0) {
							roles += ', ';
						}
						roles += arr[i];
					}
				}
				options.roles = roles;
                options.appName = App.getState().appName;
                options.appVersion = App.getState().currentVersion;
                return view.template(options)
			},
		});
		return FooterView;
	});
