define([
    'Global', 'App', 'HomesVet',
    'Text!../html/templates/navbars/header.html'
],
    function (Global, App, HomesVet, headerTemplate) {
        var view,options,
        headerView = Backbone.View.extend({
            initialize: function () {
				view = this;
				view.template = _.template(headerTemplate);
                options = {
                	name: '',
                	birthDate: '',
                	ssn: '',
                	homesID: ''
                    }
            },
            render: function (data) {
				for (var key in data) {
					options[key] = data[key];
				}
				var vet = HomesVet.getCurrentVet();
				if (vet) {
					options.isVetSelected = true;
					options.name = vet.get('lastName') + ', ' + vet.get('firstName');
					options.birthDate = view.dateData(vet);
					options.ssn = displaySSN(vet.get('sSN'));
					options.homesID = view.getDisplayHomesID(vet);
				} else {
					options.isVetSelected = false;
				}

                options.isOnline = App.getState().isHomesOnline();
                options.searchTitle = view.getDisplayTitle();

                return view.template(options);
            },
			getDisplayHomesID: function(vet) {
				if (vet.isLocal() || vet.get('veteranID') == '-1') {
					return 'N/A - Saved Locally';
				} else {
					return vet.get('veteranID');
				}
			},
			getDisplayTitle: function() {
                if (App.getState().isHomesOnline()) {
                    return 'Search for Veteran';
                } else {
                	return 'View Saved Veterans';
                }
			},
            dateData: function(vet) {
            	var age = getYearAge(vet.get('dateOfBirth'));
            	var text = formatDateNoTime(vet.get('dateOfBirth')) + ' (' + age + ') ' + vet.get('gender');
            	return text;
            }
        });
        return headerView;
    }
);