define(
	[ 'Global', 'App', 'Templates', 'FormRules',
	'Responses', 'Response', 'MainView',
	'Text!../html/templates/panes/homes/form.html',
	'Text!../html/templates/panes/homes/formItem.html'
	],
	function(Global, App, Templates, FormRules,
			Responses, Response, MainView,
			listTemplate, listItemTemplate) {
		'use strict';
		var view;
		var questions;
		var questionHash,answerHash;
		var FormView = Backbone.View.extend({
			id:				'form-assessment',
			tagName:		'div',
			attributes : {
				'class':	'homes-assessment'
			},
			initialize : function(metaData) {
				view = this;
				view.listTemplate = _.template(listTemplate);
				view.listItemTemplate = _.template(listItemTemplate);
				view.metaData = metaData ? metaData : {};
			},
			render : function() {
				view.form = App.getState().historyForm;
				view.$el.empty();
				view.$el.append(view.listTemplate(view.metaData))
				view.buildList();
				var $container = $('#main').find(":jqmData(role='content')");
				$container.empty().append(view.$el).trigger('create');
				return view;
			},
			events: {
			},
			buildList:	function() {
				view.$el.find('ul').empty();

				if (view.form.FormType==App.getConstants().DS_FORM) {
					questionHash = Templates.questionHash_HDS;
					answerHash = Templates.answerHash_HDS;
				} else if (view.form.FormType==App.getConstants().ASSESSMENT_FORM) {
					questionHash = Templates.questionHash_HOMES;
					answerHash = Templates.answerHash_HOMES;
				}

				view.$el.find('ul').append(view.listItemTemplate({
					question:		'Date of Assessment',
					answer:			[Responses.instance().getAnswer('txtAssessmentDate')],
					classes:		classes
				}));

				for (var id in questionHash) {
					questions = questionHash[id];
					for (var i in questions) {
						var question = questions[i];
						if (FormRules.getDisplayLogic().isQuestionDisplayed(question)) {
							var response = Responses.instance().getAnswer(question.vaId);
							var displayAnswer = view.getDisplayAnswer(question,response);
							var classes = '';
							if (FormRules.getDisplayLogic().isSubQuestion(question)) {
								classes += ' indent';
							}
							view.$el.find('ul').append(view.listItemTemplate({
								question:		question.text,
								answer:			displayAnswer,
								classes:		classes
							}));
						}
					}
				}
				view.$el.find('ul').trigger('create');
			},
			translateToText: function(val,possibleAnswers) {
				for (var i in possibleAnswers) {
					if (possibleAnswers[i].value == val.toLowerCase()) {
						return possibleAnswers[i].text;
					}
				}
				return val;
			},
			getDisplayAnswer: function(question,response) {
				var displayAnswer = [];
				if (response) {
					var possibleAnswers = FormRules.getDisplayLogic().getPossibleAnswers(answerHash,question.answerBase)
					if ($.isArray(response)) {
						for (var i in response) {
							displayAnswer.push(view.translateToText(response[i],possibleAnswers));
						}
					} else {
						displayAnswer.push(view.translateToText(response,possibleAnswers));
					}
				}
				if (question.vaId) {
					if (question.vaId==='txtHSA_Q20_Total') {
						displayAnswer.push(FormRules.getValidationLogic().getSum('Q20'))
					}
					if (question.vaId==='txtHSA_Q30_Total') {
						displayAnswer.push(FormRules.getValidationLogic().getSum('Q30'));
					}
				}
				return displayAnswer;
			}
		});
		return FormView;
	});
