define([
		'Backbone', 'Global', 'App', 'jQM', 'HomesSoap',
		'SideBar', 'HomesVet',
		'HeaderView', 'FooterView',
		'FormRules', 'HomesVets', 'HomesUser', 'Forms',
		'Text!../html/templates/panes/main.html' ],
	function(Backbone, Global, App, jQM, HomesSoap,
			SideBar, HomesVet,
			HeaderView, FooterView,
			FormRules, HomesVets, HomesUser, Forms,
			mainTemplate) {
		var view, callback;
		var searchType;
		var MainView = Backbone.View.extend({
			id : 'main',
			attributes : {
				'data-role':		'page',
				'class':			'type-interior ui-page'
			},
			initialize : function() {
				this.mainTemplate = _.template(mainTemplate);
				view = this;
                                            
                                            //
                                            //  *************************************************************
                                            //
                                            
                                            // document.addEventListener("showEncryptedData", this.showEncryptedData);
                                            
                                            // document.addEventListener("showDecryptedData", this.showDecryptedData);
                                            
                                            //
                                            //  *************************************************************
                                            //

                                            
                                            
//				$("body").on('tap', function(e) {
//					var msg = 'KEYBOARD ';
//					msg =  'X page client screen: ' + e.pageX + ', ' + e.clientX + ', ' + e.screenX;
//					console.log(msg);
//					msg =  'Y page client screen: ' + e.pageY + ', ' + e.clientY + ', ' + e.screenY;
//					console.log(msg);
//				});
			},
			render : function(options) {
				view.options = options;
				console.log('mainView options=' + JSON.stringify(view.options));
				var $container = view.$el;
				view.options.isLoggedIn = HomesUser.instance().isLoggedIn();
				view.options.online = App.getState().isHomesOnline();
				$container.empty().append(view.mainTemplate(options));
				$container.find('#header').append((new HeaderView()).render(view.options));
				$container.find(":jqmData(role='footer')").append((new FooterView()).render(view.options));
				$container.trigger('create');
				SideBar.modifyButtons();
                view.$el.on('orientationchange', function () {
                	console.log('orientationchange');
                	// if the keyboard is up we have a race between keyboard up/down events and this event which might cause
                	// the isKeyboardShown flag to be inaccurate. So wait for the other events to finish
                	setTimeout(function() {
                		if (App.getState().isKeyboardShown) {
//    		                cordova.exec(
//    			                	function(height) {
//    			                		console.log("KEYBOARD screenHeight setting maxHeight=" + height);
//    			                        App.getState().maxHeight = height;
//    			                		// screen height does not take keyboard height into account, so dont call resize when it is up
//    			                    	// a rotation when the keyboard is up causes a DOWN then UP cordova callbacks so the screen height
//    			                    	// is taken care of in that case
//    			                	},
//    			                	function() {
//    			                		console.log("KEYBOARD screenHeight ERROR");
//    			                	},
//    			                	"KeyboardNotification","screenHeight",[]);
                		} else {
    		                cordova.exec(
    			                	function(height) {
    			                		console.log("KEYBOARD screenHeight setting contentHeight=" + height);
    			                        App.getState().contentHeight = height;
    			    	                Global.getUtilities().resizeUseSaved();
    			                	},
    			                	function() {
    			                		console.log("KEYBOARD screenHeight ERROR");
    			                	},
    			                	"KeyboardNotification","screenHeight",[]);
                		}
                	},200);
                  });
				return $container;
			},
			events: {
				'click #search-btn':			'noVet',
				'click #logout-btn':			'logout',
				'click #contact-btn':			'contact',
				'click #history-btn':			'showHistory',
				'click #assessment-btn':		'showAssessment',
				'click #decision-btn':			'showDecision',
				'click #saved-data':			'showSavedData',
				'click #config-btn':			'showConfig',
				'click #about-btn':				'showAbout',
				'click #connect-btn':			'connect',
				'submit #requestForm':			'search',
				'click #newVetOffline':			'newVetOffline',
				'click #help':					'help'
			},
			help: function(e) {
				$('.helpText').toggleClass('displayed');
			},
			noVet: function(e) {
				e.preventDefault();
				e.stopPropagation();
				HomesVet.setCurrentVet(null);
				if (App.getState().isHomesOnline()) {
					Global.getUtilities().eventAggregator.invoke('blank');
				} else {
					Global.getUtilities().eventAggregator.invoke('homesSavedData');
				}
			},
			newVetOffline: function(e) {
				e.preventDefault();
				e.stopPropagation();
				HomesVet.setCurrentVet(null);
				Global.getUtilities().eventAggregator.invoke('homesVeteranSummary');
			},
			search: function(e) {
				e.preventDefault();
				e.stopPropagation();
				if (App.getState().isHomesOnline()) {
					view.searchOnline();
				} else {
					// not working
//					view.searchOffline();
					HomesVets.instance([]);
					Global.getUtilities().eventAggregator.invoke('homesList');
                    MainView.refresh();
				}
			},
			searchOnline: function() {
				var searchQuery = $('#search-field').val();
				searchType = homesSearchType(searchQuery);
				if (view.validateQuery(searchQuery)) {
					App.getUtilities().alert("search called");
					App.getUtilities().alert(HomesUser.instance().get('SessionID'));
					HomesVets.clearInstance();

					var options = {
						sessionId:		HomesUser.instance().get('SessionID'),
						loginId:		HomesUser.instance().get('StaffID'),
						username:		HomesUser.instance().get('username'),
						searchQuery:    searchQuery,
						searchType:     searchType,
					};
					options = App.getUtilities().validateSearchOptions(options);
					console.log('options=' + JSON.stringify(options));

					if (options) {
						HomesSoap.getVets(options, function(obj) {
							if (obj.success) {
								var data = obj.successData;
//								console.log('data=' + JSON.stringify(data));
//								console.log('TEST got vets');
								HomesVets.instance(data);
								Global.getUtilities().eventAggregator.invoke('homesList');
							} else {
								if (App.getState().isHomesOnline()) {
									Global.getUtilities().reportError('HOMES error', obj.errorData);
								} else {
									Global.getUtilities().reportError('HOMES is Offline', obj.errorData);
								}
								Global.getUtilities().eventAggregator.invoke('homesSavedData');
                                MainView.refresh();
							}
						});
					}
				}
			},
			validateQuery: function(searchQuery) {
				if (searchType == SEARCH_TYPE_UNKNOWN) {
					Global.getUtilities().eventAggregator.trigger('message', 'searchValidationError',
							['The selected search query format does not match any of the following types',
							'SSN which is exactly 9 digits',
							'HOMES ID which is 1-8 digits',
							'First letter of last name followed by last 4 digits of SSN',
							'Last Name']);
					return false;
				}
				return true;
			},
			refresh: function(id) {
				var $container = view.$el;
				view.options.isLoggedIn = HomesUser.instance().isLoggedIn();
				view.options.online = App.getState().isHomesOnline();
				console.log('refresh isLoggedIn=' + view.options.isLoggedIn
						+ ', online=' + view.options.online
						+ ', 403=' + App.getState().error403);
//				$container.find(":jqmData(role='header')").empty().append((new HeaderView()).render(view.options));
				$container.find('#header').empty().append((new HeaderView()).render(view.options));
				$container.find(":jqmData(role='footer')").empty().append((new FooterView()).render(view.options));
				$container.trigger('create');
				SideBar.modifyButtons(id);
			},
			connect: function(e) {
				e.preventDefault();
				e.stopPropagation();
                                            
                                            //
                                            //  *************************************************************
                                            //
                                            
                                            // var parameters = { userId: 'cprs1234', homesId: '12345', eventName: 'showEncryptedData' };
                                            
                                            // var data = { firstName: 'Fred', lastName: 'Throckmorton', isVet: true };
                                            
                                            // alert("Data to be encrypted = " + JSON.stringify(data));
                                            
                                            // window.location = "encrypt://fake.host/" + btoa(JSON.stringify(data)) + "?" + btoa(JSON.stringify(parameters));
                                            
                                            //
                                            //  *************************************************************
                                            //
                                            
                                            
                Global.getUtilities().eventAggregator.trigger('connect');
			},
			showSavedData: function(e) {
				e.preventDefault();
				e.stopPropagation();
                App.getState().showBackButton = false;

				Global.getUtilities().eventAggregator.invoke('homesSavedData');
			},
                                            
                                            
                                            
                                            //
                                            //  **********************************************************
//                                            //
//                                        showEncryptedData: function(e) {
//                                            e.preventDefault();
//                                            e.stopPropagation();
                                            
                                            
//                                            alert("Encrypted object data = " + atob(e.detail));
                                            
//                                            var parameters = { userId: 'cprs1234', homesId: '12345', eventName: 'showDecryptedData' };
                                            
//                                            var  data = JSON.parse(atob(e.detail));
                                            
                                            
//                                            window.location = "decrypt://falke.host/" + btoa(JSON.stringify(data)) + "?" + btoa(JSON.stringify(parameters));

//                                        },
//                                        showDecryptedData: function(e) {
//                                            e.preventDefault();
//                                            e.stopPropagation();
                                            
//                                            alert("Decrypted Data = " + atob(e.detail));
                                            
//                                        },
                                            
                                            //
                                            //  *************************************************************
                                            //
                                            
                                            
                                            
			contact: function(e) {
				e.preventDefault();
				e.stopPropagation();
				Global.getUtilities().eventAggregator.invoke('homesVeteranSummary');
			},
			showDecision: function(e) {
				e.preventDefault();
				e.stopPropagation();
				Global.getUtilities().eventAggregator.invoke('hds');
			},
			showAssessment: function(e) {
				e.preventDefault();
				e.stopPropagation();
                var hasEpisode = HomesVet.getCurrentVet() && HomesVet.getCurrentVet().get('isHomesEpisodeOpen');

                if (hasEpisode) {
                    if (HomesVet.getCurrentVet().get('homesEpisodeVISN') == HomesUser.instance().get('VISN')) {
                        Global.getUtilities().eventAggregator.trigger('message', 'openEpisodeInProgressInVISN',
                        		'There is already an open HOMES Episode in your VISN ('
                        		+ HomesVet.getCurrentVet().get('homesEpisodeVISN') + ') for this Veteran');
                    } else {
                        Global.getUtilities().eventAggregator.trigger('message', 'openEpisodeInProgressOutsideVISN',
                        		['There is already an open HOMES Episode in VISN '
                        		 + HomesVet.getCurrentVet().get('homesEpisodeVISN')
                        		 + ' for this Veteran.',
                        		 'If you wish to complete this Assessment, you will need to transfer the Veteran data to your VISN ('
                        		 + HomesUser.instance().get('VISN') + ').']);
                    }
                    // HMLS-813 put on hold for now
//                    Global.getUtilities().eventAggregator.invoke('homesVeteranSummary');
                    Global.getUtilities().eventAggregator.invoke('homesAssessment');
               } else {
                   Global.getUtilities().eventAggregator.invoke('homesAssessment');
               }
			},
			showHistory: function(e) {
				e.preventDefault();
				e.stopPropagation();
				Global.getUtilities().eventAggregator.invoke('history');
			},
			showConfig: function(e) {
				e.preventDefault();
				e.stopPropagation();
				Global.getUtilities().eventAggregator.invoke('config');
			},
			showAbout: function(e) {
				e.preventDefault();
				e.stopPropagation();

                if (App.getState().veteranSummaryIsEditing == true && App.getState().currentView == 'homesVeteranSummary') {
                    Global.getUtilities().eventAggregator.trigger('message', 'confirmAbout', '', view);
                } else {
                    Global.getUtilities().eventAggregator.invoke('about');
                }
			},
			logout: function(e) {
				if (e) {
					e.preventDefault();
					e.stopPropagation();
				}
				HomesUser.instance().logout();
				HomesUser.instance().forgetStoredCreds();
				HomesVets.clearInstance();
				Forms.clearInstance();
				HomesVet.setCurrentVet(null);
				Global.getUtilities().eventAggregator.invoke('homesLogin');
			},

            messageCallBack: function() {
                if (App.getState().okMessagePressed) {
                    Global.getUtilities().eventAggregator.invoke('about');
                }
			}
		});

		MainView.refresh = function(id) {
			if (view) {
				view.refresh(id);
			}
		}

		MainView.logout = function(id) {
			if (view) {
				view.logout();
			}
		}

		return MainView;
	}
);
