define(
	[ 'App', 'Global',
	  'Text!../html/templates/panes/message.html' ],
	function(App, Global, template) {
		var singleInstance, view,
		MessageView = Backbone.ModalView.extend({
			initialize : function() {
				view = this;
				view.template = _.template(template);
				_.bindAll( this, "render");
				App.getState().okMessagePressed = false;
				App.getState().cancelMessagePressed = false;
			},
            render: function (data) {
            	view.options = data;
             	if (data.messageClass==='msg-confirmation') {
            		view.options.bar = 'e';
            		view.options.theme = 'e';
            	} else if (data.messageClass==='msg-error') {
            		view.options.bar = 'd';
                	view.options.theme = 'd';
            	} else if (data.messageClass==='msg-info') {
            		view.options.bar = 'b';
                	view.options.theme = 'b';
            	} else {
            		view.options.bar = 'b';
                	view.options.theme = 'b';
            	}
            	view.$el.append(this.template(view.options));
            	$('#messageBox').keypress(function(event) {
    				console.log('key pressed' + event.keyCode);
            		});

            	return view;
            },
			events: {
				"tap #ok-btn":			"okAction",
				"tap #cancel-btn":		"cancelAction",
                "tap #secondaryOk-btn": "secondaryAction",
				'submit #message':		'okAction'
			},
			okAction: function( event) {
				console.log('ok pressed');
				event.preventDefault();
				this.hideModal();
				App.getState().okMessagePressed = true;
                App.getState().secondaryActionPressed = false;
                App.getState().cancelMessagePressed = false;
				if (typeof view.options.caller !== 'undefined') {
					view.options.caller.messageCallBack();
				}
			},
            secondaryAction: function( event) {
				console.log('secondary action pressed');
				event.preventDefault();
				this.hideModal();
				App.getState().secondaryActionPressed = true;
                App.getState().okMessagePressed = false;
                App.getState().cancelMessagePressed = false;
				if (typeof view.options.caller !== 'undefined') {
					view.options.caller.messageCallBack();
				}
			},
			cancelAction: function( event) {
				console.log('cancel pressed');
				event.preventDefault();
				this.hideModal();
				App.getState().cancelMessagePressed = true;
				App.getState().secondaryActionPressed = false;
                App.getState().okMessagePressed = false;
				if (typeof view.options.caller !== 'undefined') {
					view.options.caller.messageCallBack();
				}
			}
		});
		return MessageView;
	});