define([
	'Global',
	'App',
	'SearchModel',
	'Text!../html/templates/navbars/secondaryHeader.html'
],
	function(Global, App, SearchModel, secondaryHeader) {
		var SecondaryHeaderView = Backbone.View.extend({
			id: 'secondary',
			initialize: function(){
				this.template = _.template(secondaryHeader);
				this.searchModel = SearchModel.instance();
			},
			render: function(details){
				var template = this.template,
					container = this.$el,
					actions = details;

				if (details.rightAction) {
					actions.rightAction = $.extend({}, App.getConstants().DEFAULT_RIGHT_ACTION, details.rightAction);
				}
				if (details.leftAction) {
					actions.leftAction = $.extend({}, App.getConstants().DEFAULT_LEFT_ACTION, details.leftAction);
				}

				container.append(template(actions));
//				$('#main').find(":jqmData(role='header')").empty().append(container).trigger('create');
				return container;
			},

			events: {
				"tap #lab-i-btn": "showIButton",
				"tap #Reset-btn": "resetMedFilters",
				"tap #ResetConsult-btn": "resetConsultFilters",

				"change #secondary-header-dropdown": "changeSearch"
			},
			showIButton: function() {
				Global.getUtilities().eventAggregator.trigger('lab-results-information');
			},
			changeSearch: function() {
				var title = $("#secondary-header-dropdown option:selected").text(),
					searchModel = this.searchModel;
				$('#content-secondary').find(":jqmData(role='header') h3").text(title + " Search");
				searchModel.set({
					'title': title,
					'url': searchModel.get('dropDownContent')[title].url,
					'delayFetch': searchModel.get('dropDownContent')[title].delayFetch?true:false,
					'searchOption': searchModel.get('dropDownContent')[title].searchOption
				});
			}
		});
		return SecondaryHeaderView;
	}
);