define([
	'Global', 'App', 'HomesLib', 'HomesUser', 'MainView',
	'Text!../html/templates/panes/sud.html'
],
	function (Global, App, HomesLib, HomesUser, MainView,
			  sudTemplate) {
		var view;
		var SudView = Backbone.View.extend({
			id: 'sud',
			tagName: 'div',
			attributes: {'data-role': 'dialog'},
			initialize: function (metaData) {
				view = this;
				view.template = _.template(sudTemplate);
				view.metaData = metaData ? metaData : {};
				//view.metaData.content = static text is in the template now
			},
			render: function () {
				this.$el
					.empty()
					.append(this.template(view.metaData));
				var $container = $('body');
				$container.append(this.$el);
				view.delegateEvents(view.events); // we lose the event handlers if the router reloads this page
			},
			events: {
				'tap #accept-btn': 'accept',
				'tap #decline-btn': 'decline',
				'tap .ui-header a[Title="Close"]': 'decline'
			},
			accept: function (e) {
				e.preventDefault();
				e.stopPropagation();

				HomesUser.instance().set('SUDAcceptedDate',formatDateLongForm(new Date()));
				HomesLib.sendSUD(view.sudCallback);
			},
			decline: function (e) {
				e.preventDefault();
				e.stopPropagation();
				HomesUser.instance().logout();
				Global.getUtilities().eventAggregator.invoke('homesLogin');
//				Global.getUtilities().eventAggregator.trigger('message', 'mustAgree', '', view);
			},
//			close: function (e) {
//				e.preventDefault();
//				e.stopPropagation();
//				HomesUser.instance().logout();
//				Global.getUtilities().eventAggregator.invoke('homesLogin');
//
////				Global.getUtilities().eventAggregator.trigger('message', 'mustAgree', '', view);
////				Global.getUtilities().eventAggregator.invoke('sud');
//			},
			sudCallback: function(obj) {
				if (obj.success) {
                    console.log("Success sending" + obj.successData);
    				if (App.getState().isHomesOnline()) {
    					Global.getUtilities().eventAggregator.invoke('blank');
    				} else {
    					Global.getUtilities().eventAggregator.invoke('homesSavedData');
    				}
				} else {
					console.log("Could not save the SUD: " + obj.errorData);
					// does not show correctly because the sud is a popup already
//					Global.getUtilities().reportError('Could not save the SUD',obj.errorData);
					HomesUser.instance().logout();
					Global.getUtilities().eventAggregator.invoke('homesLogin');
				}
			}
//			messageCallBack: function() {
//				if (App.getState().okMessagePressed) {
//				} else {
//					HomesUser.instance().logout();
//					Global.getUtilities().eventAggregator.invoke('homesLogin');
//				}
//			}
		});
		return SudView;
	}
);
