﻿Imports System.Text
Imports System.Net
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports System.Web.Services.Protocols

<TestClass()> Public Class VaHomesWsTest
    Private Const ADMINISTRATOR As String = "MDM\Administrator"
    Private Const ADMINISTRATOR_PWD As String = "Agilexadmin99%"
    Private Const HOMESCASEMANAGER As String = "MDM\homescasemanager"
    Private Const HOMESCASEMANAGER_PWD As String = "Agilexadmin99$_"

    Private Const VET_FOUR_ID As Long = 4
    Private Const VET_FOUR_SSN As String = "666001004"

    Private Const ASSESSMENT_DATE_Q_ID As String = "txtAssesmentDate"
    Private Const TEN_YEARS As Integer = 10

    Private _cookies As System.Net.CookieContainer
    Private _homesWs As New HDSSvcWebRef.HDSSvc
    Private _sessionId As Long
    Private _userSession As HDSSvcWebRef.UserSession

    <TestMethod()> Public Sub LogIn()
        _cookies = New CookieContainer
        _homesWs.CookieContainer = _cookies
        '_userSession = _homesWs.LogIn(ADMINISTRATOR, ADMINISTRATOR_PWD)
        _userSession = _homesWs.LogIn(HOMESCASEMANAGER, HOMESCASEMANAGER_PWD)
        Assert.IsNotNull(_userSession)
        Assert.IsNotNull(_userSession.SessionID > 0)
        _sessionId = _userSession.SessionID
        Assert.IsNotNull(_userSession.User)
        Assert.IsNotNull(_userSession.User.Facility)
        Assert.IsNotNull(_userSession.User.StaffName)
        Assert.IsNotNull(_userSession.User.Roles)
    End Sub
    <TestMethod()> Public Sub GetVeteranListBySSN()
        LogIn()
        Dim veterans As List(Of HDSSvcWebRef.Veteran) = _homesWs.GetVeteranListBySSN(ADMINISTRATOR, _sessionId, VET_FOUR_SSN).ToList()
        Assert.IsNotNull(veterans)
        Assert.IsTrue(veterans.Count > 0)
    End Sub

    <TestMethod()> Public Sub GetVeteranListByLast4()
        LogIn()
        Dim veterans As List(Of HDSSvcWebRef.Veteran) = _homesWs.GetVeteranListByLast4(ADMINISTRATOR, _sessionId, "Z1004").ToList()
        Assert.IsNotNull(veterans)
        Assert.IsTrue(veterans.Count > 0)
    End Sub

    <TestMethod()> Public Sub GetVeteranListByName()
        LogIn()
        Dim veterans As List(Of HDSSvcWebRef.Veteran) = _homesWs.GetVeteranListByName(ADMINISTRATOR, _sessionId, "FOUR").ToList()
        Assert.IsNotNull(veterans)
        Assert.IsTrue(veterans.Count > 0)
    End Sub

    <TestMethod()> Public Sub AddThenEditVeteran()

        Const TEST_EMAIL As String = "test@domain"

        LogIn()

        Dim ssn As String = generateNewSSN()
        If String.IsNullOrWhiteSpace(ssn) Then
            Assert.Inconclusive("Random generator was not able to generate a SSN which does not exist in the database.")
        End If
        Dim vet As HDSSvcWebRef.Veteran = createVeteran(ssn)
        vet = _homesWs.AddOrEditVeteran(vet, _sessionId, ADMINISTRATOR)
        Assert.IsNotNull(vet)
        Assert.IsTrue(vet.VeteranID > 0)

        vet.Email = TEST_EMAIL
        vet.LastActionDate = DateTime.Today
        vet = _homesWs.AddOrEditVeteran(vet, _sessionId, ADMINISTRATOR)

        vet = testGetVeteran(vet.VeteranID)
        Assert.AreEqual(vet.Email, TEST_EMAIL)

        testGetVeteranListByName()
    End Sub

    Private Function testGetVeteran(ByVal id As Long) As HDSSvcWebRef.Veteran
        Dim vet As HDSSvcWebRef.Veteran = _homesWs.GetVeteran(ADMINISTRATOR, _sessionId, id)
        Assert.IsNotNull(vet)
        Return vet
    End Function

    Private Sub testGetVeteranListByName()
        Dim veterans As List(Of HDSSvcWebRef.Veteran) = _homesWs.GetVeteranListByName(ADMINISTRATOR, _sessionId, "ZzUnitTest").ToList()
        Assert.IsNotNull(veterans)
        Assert.IsTrue(veterans.Count > 0)
    End Sub

    Private Function generateNewSSN() As String
        Dim i As Integer = 0
        Dim ssnGen As New Random
        Dim ssn As String = vbNullString
        While (i <= 10)
            ssn = ssnGen.Next(10, 999999999).ToString
            Dim veterans As List(Of HDSSvcWebRef.Veteran) = _homesWs.GetVeteranListBySSN(ADMINISTRATOR, _sessionId, ssn).ToList()
            If veterans Is Nothing Or (veterans.Count = 0) Then
                Exit While
            End If
            i = i + 1
        End While
        Return ssn
    End Function
    Private Function createVeteran(ByVal vetSSN As String) As HDSSvcWebRef.Veteran
        Dim newVeteran As New HDSSvcWebRef.Veteran
        newVeteran.LastName = "ZzUnitTest"
        newVeteran.FirstName = "vaHomesWsUnitTest"
        newVeteran.DateOfBirth = #1/1/1975#
        newVeteran.SSN = vetSSN
        newVeteran.SSNType = SSNTypes.FullSSNReported
        newVeteran.Gender = "Female"
        newVeteran.Address1 = "5515 Parkstone Drive"
        newVeteran.City = "Chantilly"
        newVeteran.State = "VA"
        newVeteran.ZipCode = "20152"
        newVeteran.POCName = "vaHomesWs Unit Test"
        newVeteran.POCRelationship = POCRelationships.Parent
        newVeteran.CreationDate = DateTime.Today
        Return newVeteran
    End Function

    <TestMethod()> Public Sub SubmitThenGetAssessmentForms()
        LogIn()
        Dim ssn As String = generateNewSSN()
        If String.IsNullOrWhiteSpace(ssn) Then
            Assert.Inconclusive("Random generator was not able to generate a SSN which does not exist in the database.")
        End If
        Dim vet As HDSSvcWebRef.Veteran = createVeteran(ssn)
        vet = _homesWs.AddOrEditVeteran(vet, _sessionId, ADMINISTRATOR)
        Assert.IsNotNull(vet)
        Assert.IsTrue(vet.VeteranID > 0)
        Dim vetId As Long = vet.VeteranID

        Dim newAss As HDSSvcWebRef.VeteranAssessment = createAssessment(vetId)
        Dim newFormID As Long = _homesWs.SubmitAssessmentForm(ADMINISTRATOR, _sessionId, newAss)
        Assert.IsTrue(newFormID > 0)

        Dim latestAss As HDSSvcWebRef.VeteranAssessment = _homesWs.GetVeteranLastestAssessmentForm(ADMINISTRATOR, _sessionId, vetId)
        Assert.IsNotNull(latestAss)
        Assert.IsTrue(latestAss.FormID = newFormID)

        latestAss = _homesWs.GetAssessmentForm(ADMINISTRATOR, _sessionId, newFormID)
        Assert.IsNotNull(newAss.Responses)
        Assert.IsTrue(newAss.Responses.Count > 0)
        Assert.IsTrue(newAss.SiteID.Equals(_userSession.User.Facility))

        Dim assessments As List(Of HDSSvcWebRef.VeteranAssessment) = _homesWs.GetAssessmentForms(ADMINISTRATOR, _sessionId, vetId, TEN_YEARS).ToList
        Assert.IsNotNull(assessments)
        Assert.IsTrue(assessments.Count > 0)

    End Sub

    Private Function createAssessment(ByVal vetId As Long) As HDSSvcWebRef.VeteranAssessment
        Dim vetAss As New HDSSvcWebRef.VeteranAssessment
        vetAss.VeteranID = vetId
        vetAss.SubmitDate = DateTime.Now
        vetAss.SiteID = _userSession.User.Facility
        Dim responses As New List(Of HDSSvcWebRef.Response)()
        responses.Add(createResponse(ASSESSMENT_DATE_Q_ID, DateTime.Today.ToString("MM/dd/yy")))
        responses.Add(createResponse("ddlHSA_Q13", "1"))
        responses.Add(createResponse("ddlHSA_Q14", "1"))
        responses.Add(createResponse("ddlHSA_Q15", "1"))
        vetAss.Responses = responses.ToArray
        Return vetAss
    End Function

    Private Function createResponse(ByVal questionId As String, ByVal answerValue As String) As HDSSvcWebRef.Response
        Dim resp As New HDSSvcWebRef.Response()
        resp.QuestionID = questionId
        resp.ResponseValue = answerValue
        Return resp
    End Function

    <TestMethod()> Public Sub SubmitThenGetDecisionSupportForm()

        LogIn()
        Dim ssn As String = generateNewSSN()
        If String.IsNullOrWhiteSpace(ssn) Then
            Assert.Inconclusive("Random generator was not able to generate a SSN which does not exist in the database.")
        End If
        Dim vet As HDSSvcWebRef.Veteran = createVeteran(ssn)
        vet = _homesWs.AddOrEditVeteran(vet, _sessionId, ADMINISTRATOR)
        Assert.IsNotNull(vet)
        Assert.IsTrue(vet.VeteranID > 0)
        Dim vetId As Long = vet.VeteranID

        Dim newDSF As HDSSvcWebRef.VeteranDecisionSupportForm = createVeteranDecisionSupportForm(vetId)
        Dim newFormId As Long = _homesWs.SubmitDecisionSupportForm(ADMINISTRATOR, _sessionId, newDSF)
        Assert.IsTrue(newFormId > 0)

        newDSF = _homesWs.GetDecisionSuportForm(ADMINISTRATOR, _sessionId, newFormId)
        Assert.IsNotNull(newDSF)
        Assert.IsNotNull(newDSF.AlertDecisions)
        Assert.IsTrue(newDSF.AlertDecisions.Count > 0)
        Assert.IsNotNull(newDSF.ProgramScores)
        Assert.IsTrue(newDSF.ProgramScores.Count > 0)

        Dim dsforms As List(Of HDSSvcWebRef.VeteranDecisionSupportForm) = _homesWs.GetDecisionSuportForms(ADMINISTRATOR, _sessionId, vet.VeteranID, TEN_YEARS).ToList
        Assert.IsNotNull(dsforms)
        Assert.IsTrue(dsforms.Count > 0)

    End Sub

    Private Function createVeteranDecisionSupportForm(ByVal vetId As Long) As HDSSvcWebRef.VeteranDecisionSupportForm
        Dim form As New HDSSvcWebRef.VeteranDecisionSupportForm
        form.Version = "12/15/2013"
        form.VeteranID = vetId
        form.SubmitDate = DateTime.Now
        form.SiteID = _userSession.User.Facility

        Dim responses As New List(Of HDSSvcWebRef.Response)()
        responses.Add(createResponse(ASSESSMENT_DATE_Q_ID, DateTime.Today.ToString("MM/dd/yy")))
        form.Responses = responses.ToArray

        Dim alerts As New List(Of HDSSvcWebRef.AlertDecision)()
        alerts.Add(createAlertForQ1)
        form.AlertDecisions = alerts.ToArray

        Dim scores As New List(Of HDSSvcWebRef.ProgramScore)()
        scores.Add(createProgramScoreForQ4(ProgramTypes.RapidRehousing))
        scores.Add(createProgramScoreForQ4(ProgramTypes.TransitionalHousing))
        form.ProgramScores = scores.ToArray

        Return form
    End Function
    Private Function createAlertForQ1() As HDSSvcWebRef.AlertDecision
        Const Q1_ALERT As String = "Veteran does not have a safe place to stay, Veteran may need immediate short term (60 days or less) housing assistance."
        Dim responses = New List(Of HDSSvcWebRef.Response)()
        responses.Add(createResponse("HDS_Q1", "1"))
        Dim alert As New HDSSvcWebRef.AlertDecision
        alert.AlertMessage = Q1_ALERT
        alert.Responses = responses.ToArray
        Return alert
    End Function

    Private Function createProgramScoreForQ4(ByVal programType As ProgramTypes) As HDSSvcWebRef.ProgramScore
        Dim responses = New List(Of HDSSvcWebRef.Response)()

        responses.Add(createResponse("HDS_Q4A", "1"))
        responses.Add(createResponse("HDS_Q3A", "1"))
        Dim score As New HDSSvcWebRef.ProgramScore
        score.ProgramType = programType.ToString
        score.Score = 25
        score.Responses = responses.ToArray
        Return score

    End Function
    Protected Overrides Sub Finalize()
        If Not (_homesWs) Is Nothing Then
            _homesWs.Dispose()
        End If
        MyBase.Finalize()

    End Sub
End Class