﻿Imports Microsoft.VisualBasic
Imports com.agilex.homes.domain
Imports System.Data.SqlClient
Imports System.ArgumentException
Imports System.Data
Imports com.agilex.homes.domain.mock
Imports com.agilex.homes.domain.va

Namespace com.agilex.homes.dao

    Public Class UserDao
        Inherits Connection

        Private Enum StaffColumn
            Id = 0
            Name
            Username
            Email
            Login
            Facility
            Role
            LevelOfAccess
        End Enum

        Public Function fetchUser(ByVal username As String) As User
            Const STAFF_SQL As String = "SELECT s.StaffID,StaffName,StaffUserName,StaffEmail,StaffLogin,sr.Facility,r.RoleDescription,r.RoleAccessLevel" _
                                        & " FROM dbo.tbl_Staff s inner join dbo.tbl_StaffRoles sr on s.StaffID = sr.StaffID" _
                                        & " inner join dbo.tbl_StaffRoleTypes r on sr.RoleID = r.StaffRoleTypeID where s.StaffActive = 1" _
                                        & " and r.RoleActive = 1 and StaffLogin = @username"
            Me.connect()
            Dim cmd As SqlCommand = Me.createSqlCommand(STAFF_SQL)
            cmd.Parameters.AddWithValue("@username", username)
            Return translateToUser(cmd.ExecuteReader)
        End Function


        Private Function translateToUser(ByRef dr As SqlDataReader) As User
            Dim staff = New User()
            If dr IsNot Nothing Then
                Do While dr.Read()
                    staff.StaffID = dr.GetInt32(StaffColumn.Id)
                    staff.StaffName = dr.GetString(StaffColumn.Name)
                    staff.StaffEmail = dr.GetString(StaffColumn.Email)
                    staff.Facility = dr.GetString(StaffColumn.Facility)
                    Dim roles = New List(Of String)()
                    roles.Add(dr.GetString(StaffColumn.Role))
                    staff.Roles = roles
                Loop
            End If
            Return staff
        End Function

    End Class
End Namespace

