﻿Imports System.Text
Imports System.Net
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports System.Net.Http.Headers
Imports System.Net.Http
Imports System.Xml
Imports System.Web.Services.Protocols

<TestClass()> Public Class HttpStatusTest

    Private _cookies As System.Net.CookieContainer
    Private _homesWs As New vaHomesWs.vaHomesWS
    Private _sessionId As Long = 0
    Private _userSession As vaHomesWs.UserSession
    Private _httpClient As Http.HttpClient
    Private Const SSN_888999002 As String = "888999002"
    Private _newVeteran As vaHomesWs.Veteran

    Public Sub New()
        _cookies = New CookieContainer

        Dim handler As New HttpClientHandler()
        handler.CookieContainer = _cookies
        handler.UseCookies = True
        handler.AllowAutoRedirect = True
        _httpClient = New HttpClient(handler)
        _httpClient.BaseAddress = New Uri(_homesWs.Url)
    End Sub
    <TestMethod()> Public Sub testLoginReturnHttpStatusOK()
        Dim soapEnv As String = buildLoginSoapEnvelope(VaHomesWsTest.HOMES_USER, VaHomesWsTest.HOMES_USER_PWD)
        Dim request As New HttpRequestMessage(HttpMethod.Post, _homesWs.Url)
        Dim content As HttpContent = New StringContent(soapEnv.ToString, Encoding.UTF8, "application/soap+xml")
        request.Method = HttpMethod.Post
        request.Content = content
        Dim response As HttpResponseMessage = _httpClient.PostAsync(_homesWs.Url, content).GetAwaiter.GetResult
        Assert.AreEqual(HttpStatusCode.OK, response.StatusCode)
    End Sub

    Private Function buildLoginSoapEnvelope(ByVal userId As String, ByVal password As String) As String
        Dim soapEnv As New StringBuilder
        soapEnv.Append("<soap12:Envelope xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"" xmlns:soap12=""http://www.w3.org/2003/05/soap-envelope"">")
        soapEnv.Append("<soap12:Body>")
        soapEnv.Append("<LogIn xmlns=""http://tempuri.org/"">")
        soapEnv.Append(String.Format("<UserLogin>{0}</UserLogin>", userId))
        soapEnv.Append(String.Format("<UserPassword>{0}</UserPassword>", password))
        soapEnv.Append("</LogIn>")
        soapEnv.Append("</soap12:Body>")
        soapEnv.Append("</soap12:Envelope>")
        Return soapEnv.ToString

    End Function
    <TestMethod()> Public Sub testLoginReturnHttpStatusUnauthorized()
        Dim soapEnv As String = buildLoginSoapEnvelope(VaHomesWsTest.HOMES_USER, "bad pwd")
        Dim request As New HttpRequestMessage(HttpMethod.Post, _homesWs.Url)
        Dim content As HttpContent = New StringContent(soapEnv.ToString, Encoding.UTF8, "application/soap+xml")
        request.Method = HttpMethod.Post
        request.Content = content
        Dim response As HttpResponseMessage = _httpClient.PostAsync(_homesWs.Url, content).GetAwaiter.GetResult
        Assert.AreEqual(HttpStatusCode.Unauthorized, response.StatusCode)

    End Sub

    <TestMethod()> Public Sub testAccountLocked()

        Const HOMES_JNGUYEN As String = "homes\jnguyen"
        Dim soapEnv As String = buildLoginSoapEnvelope(HOMES_JNGUYEN, "bad pwd")
       
        For value As Integer = 0 To 3
            Dim request As New HttpRequestMessage(HttpMethod.Post, _homesWs.Url)
            Dim content As HttpContent = New StringContent(soapEnv.ToString, Encoding.UTF8, "application/soap+xml")
            request.Method = HttpMethod.Post
            request.Content = content
            Dim response As HttpResponseMessage = _httpClient.PostAsync(_homesWs.Url, content).GetAwaiter.GetResult
            Assert.AreEqual(HttpStatusCode.Unauthorized, response.StatusCode)
            If value = 3 Then
                Assert.IsTrue(response.ReasonPhrase.Contains("Account is Locked"))
            End If
        Next
       
    End Sub

    <TestMethod()> Public Sub testSearchReturnHttpStatusForbidden()
        login(VaHomesWsTest.HOMES_USER, VaHomesWsTest.HOMES_USER_PWD)
        Dim soapEnv As String = buildGetVeteranSoapEnvelope("bad userid", VaHomesWsTest.VET_FOUR_ID)
        Dim request As New HttpRequestMessage(HttpMethod.Post, _homesWs.Url)
        Dim content As HttpContent = New StringContent(soapEnv.ToString, Encoding.UTF8, "application/soap+xml")
        request.Method = HttpMethod.Post
        request.Content = content
        Dim response As HttpResponseMessage = _httpClient.PostAsync(_homesWs.Url, content).GetAwaiter.GetResult
        Assert.AreEqual(HttpStatusCode.Forbidden, response.StatusCode)

    End Sub
    Private Function buildGetVeteranSoapEnvelope(ByVal userId As String, ByVal vetId As Long) As String
        Dim soapEnv As New StringBuilder
        soapEnv.Append("<soap12:Envelope xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"" xmlns:soap12=""http://www.w3.org/2003/05/soap-envelope"">")
        soapEnv.Append("<soap12:Body>")
        soapEnv.Append("<GetVeteran xmlns=""http://tempuri.org/"">")
        soapEnv.Append(String.Format("<UserLogin>{0}</UserLogin>", userId))
        soapEnv.Append(String.Format("<SessionID>{0}</SessionID>", _sessionId))
        soapEnv.Append(String.Format("<VeteranID>{0}</VeteranID>", vetId))
        soapEnv.Append("</GetVeteran>")
        soapEnv.Append("</soap12:Body>")
        soapEnv.Append("</soap12:Envelope>")
        Return soapEnv.ToString
    End Function

    Private Sub login(ByVal username As String, ByVal password As String)
        _cookies = New CookieContainer
        _homesWs.CookieContainer = _cookies
        _userSession = _homesWs.LogIn(username, password)
        Assert.IsNotNull(_userSession)
        Assert.IsNotNull(_userSession.SessionID > 0)
        _sessionId = _userSession.SessionID
        Assert.IsNotNull(_userSession.User)
        Assert.IsNotNull(_userSession.User.Facility)
        Assert.IsNotNull(_userSession.User.StaffName)
        Assert.IsNotNull(_userSession.User.Roles)
    End Sub

    <TestMethod()> Public Sub testSubmitAssessment()
        login(VaHomesWsTest.HOMES_USER, VaHomesWsTest.HOMES_USER_PWD)
        Dim wsTest As New VaHomesWsTest
        _newVeteran = wsTest.AddVeteran(SSN_888999002)

        Dim soapEnv As String = buildAssessmentSoapEnvelope(VaHomesWsTest.HOMES_USER, _newVeteran.VeteranID)
        Dim request As New HttpRequestMessage(HttpMethod.Post, _homesWs.Url)
        Dim content As HttpContent = New StringContent(soapEnv.ToString, Encoding.UTF8, "application/soap+xml")
        request.Method = HttpMethod.Post
        request.Content = content
        Dim response As HttpResponseMessage
        Try
            response = _httpClient.PostAsync(_homesWs.Url, content).GetAwaiter.GetResult
        Catch e As Exception
               ug.WriteLine(e.ToString)
        End Try

    End Sub

    Private Function buildAssessmentSoapEnvelope(ByVal userId As String, ByVal vetId As Long) As String
        Dim soapEnv As New StringBuilder
        soapEnv.Append("<soap12:Envelope xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"" xmlns:soap12=""http://www.w3.org/2003/05/soap-envelope"">")
        soapEnv.Append("<soap12:Body>")
        soapEnv.Append("<SubmitAssessmentForm xmlns=""http://tempuri.org/"">")
        soapEnv.Append(String.Format("<UserLogin>{0}</UserLogin>", userId))
        soapEnv.Append(String.Format("<SessionID>{0}</SessionID>", _sessionId))
        soapEnv.Append("<Assessment>")
        soapEnv.Append(String.Format("<VeteranID>{0}</VeteranID>", vetId))
        soapEnv.Append(String.Format("<SiteID>{0}</SiteID>", 688))
        soapEnv.Append("<Responses>")
        soapEnv.Append("<Response>")
        soapEnv.Append(String.Format("<QuestionID>{0}</QuestionID>", VaHomesWsTest.ASSESSMENT_DATE_Q_ID))
        soapEnv.Append(String.Format("<ResponseValue>{0}</ResponseValue>", DateTime.Today.ToString("MM/dd/yy")))
        soapEnv.Append("</Response>")
        soapEnv.Append("</Responses>")
        soapEnv.Append("</Assessment>")
        soapEnv.Append("</SubmitAssessmentForm>")
        soapEnv.Append("</soap12:Body>")
        soapEnv.Append("</soap12:Envelope>")
        Return soapEnv.ToString

    End Function

    <TestCleanup()> Public Sub cleanup()
        If _newVeteran IsNot Nothing Then
            Dim vetDao As New VeteranDao
            vetDao.Delete(_newVeteran.SSN)
            vetDao.Dispose()
        End If
    End Sub

    Protected Overrides Sub Finalize()
        If Not (_homesWs) Is Nothing Then
            _homesWs.Dispose()
        End If
        MyBase.Finalize()

    End Sub

End Class