﻿Imports System.Text
Imports System.Net
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports System.Web.Services.Protocols

<TestClass()> Public Class VaHomesWsTest

    Public Const MODIFIED_SOURCE As String = "vaHomesWsResourceTest"

    Public Const HOMES_USER As String = "MDM\homes.user"
    Public Const HOMES_USER_PWD As String = "Hom3sUs3r!"

    Public Const VET_FOUR_ID As Long = 4
    Public Const VET_FOUR_SSN As String = "666001004"
    Public Const TEN_YEARS As Integer = 10
    Public Const ASSESSMENT_DATE_Q_ID As String = "txtAssesmentDate"
    Private Const SSN_888999001 As String = "888999001"

    Private Const SSN_888999004 As String = "888999004"
    Private Const SSN_888999003 As String = "888999003"

    Private _cookies As System.Net.CookieContainer
    Private _homesWs As New vaHomesWs.vaHomesWS
    Private _sessionId As Long
    Private _userSession As vaHomesWs.UserSession
    Private _newVeteran As vaHomesWs.Veteran

    Public Sub New()
        LogIn()
    End Sub
    <TestMethod()> Public Sub LogIn()
        _cookies = New CookieContainer
        _homesWs.CookieContainer = _cookies
        _userSession = _homesWs.LogIn(HOMES_USER, HOMES_USER_PWD)
        Assert.IsNotNull(_userSession)
        Assert.IsNotNull(_userSession.SessionID > 0)
        _sessionId = _userSession.SessionID
        Assert.IsNotNull(_userSession.User)
        Assert.IsNotNull(_userSession.User.Facility)
        Assert.IsNotNull(_userSession.User.StaffName)
        Assert.IsNotNull(_userSession.User.Roles)
        Assert.IsNotNull(_userSession.User.VISN)
    End Sub
    <TestMethod()> Public Sub SubmitSUDDate()
        LogIn()
        Dim user As vaHomesWs.User = _userSession.User
        user.SUDAcceptedDate = DateTime.Today
        Dim ok As Boolean = _homesWs.SubmitStaffSUDDate(HOMES_USER, _sessionId, user)
        Assert.IsTrue(ok)

    End Sub
    <TestMethod()> Public Sub GetVeteranListBySSN()
        Dim veterans As List(Of vaHomesWs.Veteran) = _homesWs.GetVeteranListBySSN(HOMES_USER, _sessionId, VET_FOUR_SSN).ToList()
        Assert.IsNotNull(veterans)
        Assert.IsTrue(veterans.Count > 0)
    End Sub

    <TestMethod()> Public Sub GetVeteranListByLast4()
        Dim veterans As List(Of vaHomesWs.Veteran) = _homesWs.GetVeteranListByLast4(HOMES_USER, _sessionId, "Z1004").ToList()
        Assert.IsNotNull(veterans)
        Assert.IsTrue(veterans.Count > 0)
    End Sub

    <TestMethod()> Public Sub GetVeteranListByName()
        Dim veterans As List(Of vaHomesWs.Veteran) = _homesWs.GetVeteranListByName(HOMES_USER, _sessionId, "FOUR").ToList()
        Assert.IsNotNull(veterans)
        Assert.IsTrue(veterans.Count > 0)
    End Sub

    <TestMethod()> Public Sub AddThenEditVeteran()

        Const TEST_EMAIL As String = "test@domain"
        AddVeteran(SSN_888999001)
        
        _newVeteran.Email = TEST_EMAIL
        _newVeteran.LastActionDate = DateTime.Today
        _newVeteran = _homesWs.AddOrEditVeteran(_newVeteran, _sessionId, HOMES_USER)

        _newVeteran = testGetVeteran(_newVeteran.VeteranID)
        Assert.AreEqual(_newVeteran.Email, TEST_EMAIL)

        testGetVeteranListByName()
    End Sub
    <TestMethod()> Public Sub testUpdateSSN()

        AddVeteran(SSN_888999003)

        _newVeteran.SSN = SSN_888999004
        _newVeteran.LastActionDate = DateTime.Today
        _newVeteran = _homesWs.AddOrEditVeteran(_newVeteran, _sessionId, HOMES_USER)

        _newVeteran = testGetVeteran(_newVeteran.VeteranID)
        Assert.AreEqual(_newVeteran.SSN, SSN_888999004)

    End Sub

    Private Function testGetVeteran(ByVal id As Long) As vaHomesWs.Veteran
        Dim vet As vaHomesWs.Veteran = _homesWs.GetVeteran(HOMES_USER, _sessionId, id)
        Assert.IsNotNull(vet)
        Return vet
    End Function

    Private Sub testGetVeteranListByName()
        Dim veterans As List(Of vaHomesWs.Veteran) = _homesWs.GetVeteranListByName(HOMES_USER, _sessionId, "ZzUnitTest").ToList()
        Assert.IsNotNull(veterans)
        Assert.IsTrue(veterans.Count > 0)
    End Sub

    
    Public Function AddVeteran(ByVal ssn As String) As vaHomesWs.Veteran
        If _newVeteran IsNot Nothing Then
            Return _newVeteran
        End If
        _newVeteran = New vaHomesWs.Veteran
        _newVeteran.LastName = "ZzUnitTest"
        _newVeteran.FirstName = MODIFIED_SOURCE
        _newVeteran.DateOfBirth = #1/1/1975#
        _newVeteran.SSN = ssn
        _newVeteran.SSNType = SSNTypes.FullSSNReported
        _newVeteran.Gender = "Female"
        _newVeteran.Address1 = "5515 Parkstone Drive"
        _newVeteran.City = "Chantilly"
        _newVeteran.State = "VA"
        _newVeteran.ZipCode = "20152"
        _newVeteran.POCName = "vaHomesWs Unit Test"
        _newVeteran.POCRelationship = POCRelationships.Parent
        _newVeteran.CreationDate = DateTime.Today
        _newVeteran = _homesWs.AddOrEditVeteran(_newVeteran, _sessionId, HOMES_USER)
        Assert.IsNotNull(_newVeteran)
        Assert.IsTrue(_newVeteran.VeteranID > 0)
        Return _newVeteran
    End Function

    <TestMethod()> Public Sub GetOpenEpisodeAssessment()
        ' Create a veteran
        Dim vet As vaHomesWs.Veteran = AddVeteran(SSN_888999001)
        Dim vetId As Long = vet.VeteranID
        ' Submit an assessment
        Dim newAss As vaHomesWs.VeteranAssessment = createAssessment(vetId)
        Dim newFormID As Long = _homesWs.SubmitAssessmentForm(HOMES_USER, _sessionId, newAss)
        Assert.IsTrue(newFormID > 0)
        Dim openEpisodeAss As vaHomesWs.VeteranAssessment = _homesWs.GetOpenEpisodeAssessment(HOMES_USER, _sessionId, vetId)
        Assert.IsNotNull(openEpisodeAss)
        Assert.IsTrue(openEpisodeAss.VISN.ToString.Equals(_userSession.User.VISN))

    End Sub
    <TestMethod()> Public Sub SubmitThenGetAssessmentForms()

        ' Create a veteran
        Dim vet As vaHomesWs.Veteran = AddVeteran(SSN_888999001)
        Dim vetId As Long = vet.VeteranID
        ' Submit an assessment
        Dim newAss As vaHomesWs.VeteranAssessment = createAssessment(vetId)
        Dim newFormID As Long = _homesWs.SubmitAssessmentForm(HOMES_USER, _sessionId, newAss)
        Assert.IsTrue(newFormID > 0)

        Dim latestAss As vaHomesWs.VeteranAssessment = _homesWs.GetAssessmentForm(HOMES_USER, _sessionId, newFormID)
        Assert.IsNotNull(latestAss.Responses)
        Assert.IsTrue(latestAss.Responses.Count > 0)
        Assert.IsTrue(latestAss.SiteID.Equals(_userSession.User.Facility))
        Assert.IsNotNull(latestAss.AssessmentDate)
        Assert.IsNotNull(latestAss.SubmitDate)
        Assert.IsNotNull(latestAss.VISN)

        Dim assessments As List(Of vaHomesWs.VeteranAssessment) = _homesWs.GetAssessmentForms(HOMES_USER, _sessionId, vetId, TEN_YEARS).ToList
        Assert.IsNotNull(assessments)
        Assert.IsTrue(assessments.Count > 0)

        ' Get Veteran latest assessment and compare to the one just submitted
        latestAss = _homesWs.GetVeteranLastestAssessmentForm(HOMES_USER, _sessionId, vetId)
        Assert.IsNotNull(latestAss)
        Assert.IsTrue(latestAss.FormID = newFormID)
        Assert.IsNotNull(latestAss.Responses)
        Assert.IsTrue(latestAss.Responses.Count > 0)
        Assert.IsNotNull(latestAss.AssessmentDate)
        Assert.IsNotNull(latestAss.SubmitDate)
        Assert.IsNotNull(latestAss.VISN)
    End Sub

    
    Private Function createResponse(ByVal questionId As String, ByVal answerValue As String) As vaHomesWs.Response
        Dim resp As New vaHomesWs.Response()
        resp.QuestionID = questionId
        resp.ResponseValue = answerValue
        Return resp
    End Function

    <TestMethod()> Public Sub SubmitThenGetDecisionSupportForm()

        Dim vet As vaHomesWs.Veteran = AddVeteran(SSN_888999001)
        Dim vetId As Long = vet.VeteranID

        Dim newDSF As vaHomesWs.VeteranDecisionSupport = createDecisionSupport(vetId)
        Dim newFormId As Long = _homesWs.SubmitDecisionSupportForm(HOMES_USER, _sessionId, newDSF)
        Assert.IsTrue(newFormId > 0)

        newDSF = _homesWs.GetDecisionSuportForm(HOMES_USER, _sessionId, newFormId)
        Assert.IsNotNull(newDSF.AlertDecisions)
        Assert.IsTrue(newDSF.AlertDecisions.Count = 1)
        Assert.IsNotNull(newDSF.ProgramScores)
        Assert.IsTrue(newDSF.ProgramScores.Count = 2)
        Assert.IsNotNull(newDSF.AssessmentDate)
        Assert.IsNotNull(newDSF.SubmitDate)
        Assert.IsNotNull(newDSF.VISN)
        Assert.IsTrue(newDSF.SiteID.Equals(_userSession.User.Facility))
        Assert.IsNotNull(newDSF.Recommendations)
        Assert.IsTrue(newDSF.Recommendations.Count > 1)

        Dim recommendation As vaHomesWs.Recommendation = newDSF.Recommendations.ToList().Item(0)

        Assert.IsTrue(String.IsNullOrEmpty(recommendation.RejectedReason))
        If recommendation.Status.Equals("Rejected") Then
            Assert.IsNotNull(recommendation.RejectedReasonTypes)
            Assert.IsTrue(recommendation.RejectedReasonTypes.Count > 0)
        End If

        recommendation = newDSF.Recommendations.ToList().Item(1)
        If recommendation.Status.Equals("Rejected") Then
            Assert.IsNotNull(recommendation.RejectedReasonTypes)
            Assert.IsTrue(recommendation.RejectedReasonTypes.Count > 0)
        End If

        Dim dsforms As List(Of vaHomesWs.VeteranDecisionSupport) = _homesWs.GetDecisionSuportForms(HOMES_USER, _sessionId, vetId, TEN_YEARS).ToList
        Assert.IsNotNull(dsforms)
        Assert.IsTrue(dsforms.Count > 0)

    End Sub

    Private Function createDecisionSupport(ByVal vetId As Long) As vaHomesWs.VeteranDecisionSupport
        Dim form As New vaHomesWs.VeteranDecisionSupport
        form.Version = "12/15/2013"
        form.VeteranID = vetId
        form.SubmitDate = DateTime.Now
        form.SiteID = _userSession.User.Facility
        form.ModifiedSource = MODIFIED_SOURCE

        Dim formResponses As New List(Of vaHomesWs.Response)()
        formResponses.Add(createResponse(ASSESSMENT_DATE_Q_ID, DateTime.Today.ToString("MM/dd/yy")))
        Dim q1Response As vaHomesWs.Response = createResponse("ddlDssQ1", "1")
        formResponses.Add(q1Response)
        formResponses.Add(createResponse("ddlDssQ2", "0"))
        Dim q3Response As vaHomesWs.Response = createResponse("ddlDssQ3", "0")
        formResponses.Add(q3Response)
        Dim q4Response As vaHomesWs.Response = createResponse("ddlDssQ4", "0")
        formResponses.Add(q4Response)
        form.Responses = formResponses.ToArray

        Dim alerts As New List(Of vaHomesWs.AlertDecision)()
        alerts.Add(createAlertForQ1(q1Response))
        form.AlertDecisions = alerts.ToArray

        Dim scores As New List(Of vaHomesWs.ProgramScore)()
        Dim responses As New List(Of vaHomesWs.Response)()
        responses.Add(q3Response)
        responses.Add(q4Response)
        scores.Add(createProgramScoreForQ4(ProgramTypes.RapidRehousing, responses))
        scores.Add(createProgramScoreForQ4(ProgramTypes.TransitionalHousing, responses))
        form.ProgramScores = scores.ToArray

        Dim recommendations As New List(Of vaHomesWs.Recommendation)()
        recommendations.Add(createRecomendation(ProgramTypes.RapidRehousing, 100))
        recommendations.Add(createRecomendationWithRejectReason(ProgramTypes.Prevention, 100))
        form.Recommendations = recommendations.ToArray

        Return form
    End Function

    Private Function createAlertForQ1(q1Response As vaHomesWs.Response) As vaHomesWs.AlertDecision
        Const Q1_ALERT As String = "Veteran does not have a safe place to stay, Veteran may need immediate short term (60 days or less) housing assistance."
        Dim responses As New List(Of vaHomesWs.Response)()
        responses.Add(q1Response)
        Dim alert As New vaHomesWs.AlertDecision
        alert.AlertMessage = Q1_ALERT
        alert.Responses = responses.ToArray
        Return alert
    End Function

    Private Function createProgramScoreForQ4(ByVal programType As ProgramTypes, responses As List(Of vaHomesWs.Response)) As vaHomesWs.ProgramScore
        Dim score As New vaHomesWs.ProgramScore
        score.ProgramType = programType.ToString
        score.Score = 25
        score.Responses = responses.ToArray
        Return score
    End Function

    Private Function createRecomendation(ByVal programType As ProgramTypes, ByVal score As Integer) As vaHomesWs.Recommendation
        Dim recommendation As New vaHomesWs.Recommendation
        recommendation.ProgramType = programType.ToString
        recommendation.TotalScore = score
        recommendation.Status = "Accepted"
        Return recommendation
    End Function
    Private Function createRecomendationWithRejectReason(ByVal programType As ProgramTypes, ByVal score As Integer) As vaHomesWs.Recommendation
        Dim recommendation As New vaHomesWs.Recommendation
        recommendation.ProgramType = programType.ToString
        recommendation.TotalScore = score
        recommendation.Status = "Rejected"
        Dim rejectReasons As New List(Of String)
        rejectReasons.Add("Program not available")
        recommendation.RejectedReasonTypes = rejectReasons.ToArray

        Return recommendation
    End Function
    Private Function createAssessment(ByVal vetId As Long) As vaHomesWs.VeteranAssessment
        Dim vetAss As New vaHomesWs.VeteranAssessment
        vetAss.VeteranID = vetId
        vetAss.SubmitDate = DateTime.Now
        vetAss.SiteID = _userSession.User.Facility
        vetAss.ModifiedSource = MODIFIED_SOURCE

        Dim responses = New List(Of vaHomesWs.Response)()
        responses.Add(createResponse(ASSESSMENT_DATE_Q_ID, DateTime.Today.ToString("MM/dd/yy")))
        responses.Add(createResponse("ddlHSA_Q5", "1"))
        responses.Add(createResponse("ddlHSA_Q6", "1"))
        responses.Add(createResponse("ddlHSA_Q52a", "0"))
        responses.Add(createResponse("ddlHSA_Q52b", "0"))
        responses.Add(createResponse("ddlHSA_Q53", "0"))
        responses.Add(createResponse("ddlHSA_Q54", "0"))

        vetAss.Responses = responses.ToArray
        Return vetAss
    End Function

    <TestMethod()> Public Sub SubmitAssessmentTwice()

        ' Create a veteran
        Dim vet As vaHomesWs.Veteran = AddVeteran(SSN_888999001)
        Dim vetId As Long = vet.VeteranID
        ' Submit an assessment
        Dim newAss As vaHomesWs.VeteranAssessment = createAssessment(vetId)
        Dim newFormID As Long = _homesWs.SubmitAssessmentForm(HOMES_USER, _sessionId, newAss)
        Assert.IsTrue(newFormID > 0)
        Dim newFormID2 As Long = 0
        Try
            newFormID2 = _homesWs.SubmitAssessmentForm(HOMES_USER, _sessionId, newAss)
            Assert.Fail("Expected an exception from the web service when re-assess within 30 days")
        Catch ex As SoapException
            Assert.IsTrue(newFormID2 = 0)
        End Try
    End Sub
    <TestCleanup()> Public Sub deleteVeteran()
        If _newVeteran IsNot Nothing Then
            Dim vetDao As New VeteranDao
            vetDao.Delete(_newVeteran.SSN)
            vetDao.Dispose()
        End If
    End Sub
    <TestInitialize()> Public Sub cleanup()

        Dim vetDao As New VeteranDao
        vetDao.Delete(SSN_888999001)
        vetDao.Delete(SSN_888999003)
        vetDao.Dispose()

    End Sub
    Protected Overrides Sub Finalize()

        If Not (_homesWs) Is Nothing Then
            _homesWs.Dispose()
        End If
        MyBase.Finalize()
    End Sub

End Class